
#include <Servo.h> // Include the Servo library 
#include <HX711.h> //Include the loadcell library

const int LOADCELL_DOUT_PIN = 2;
const int LOADCELL_SCK_PIN = 3;
HX711 scale;
long reading;
int servoPin1 = A2; // Declare the Servo pin 
Servo Servo1; // Create a servo object 
int motorpwm1=5; // Set motor1 Speed
int motorpwm2=6; // Set motor2 Speed
int motoren1=4; // motor1 forward
int motoren2=7; // motor2 forward
int motorev1=A4; //motor1 reverse
int motorev2=8; //motor2 reverse
#include <SPI.h>
#include <MFRC522.h> // Include the RFID Library

#define RST_PIN         9          // Configurable, see typical pin layout below
#define SS_PIN          10        // Configurable, see typical pin layout below

MFRC522 mfrc522(SS_PIN, RST_PIN);  // Create MFRC522 instance
int pos; // pos as 0 for on track, 1 for loading station, 2 for unloading station.

/*Typical pin layout used:
 * -------------------------------------
 *             MFRC522      Arduino     
 *             Reader/PCD   Uno/101     
 * Signal      Pin          Pin         
 * -------------------------------------
 * RST/Reset   RST          9           
 * SPI SS      SDA(SS)      10          
 * SPI MOSI    MOSI         11 / ICSP-4 
 * SPI MISO    MISO         12 / ICSP-1 
 * SPI SCK     SCK          13 / ICSP-3 */

void setup() 
{ 
   
   Serial.begin(9600);
   Servo1.attach(servoPin1); // We need to attach the servo to the used pin number 
   scale.begin(LOADCELL_DOUT_PIN, LOADCELL_SCK_PIN); // Loadcell begin
  
  pinMode(motorpwm1, OUTPUT); // Motor PWM signal
  pinMode(motorpwm2, OUTPUT);// Motor PWM signal
  pinMode(motoren1, OUTPUT); // Motor enable signal
  pinMode(motoren2, OUTPUT);// Motor enable signal
  pinMode(motorev1, OUTPUT); // Motor enable signal
  pinMode(A0, INPUT); // Input from IR Sensor
  pinMode(A1, INPUT); // Input from IR Sensor
  SPI.begin();      // Init SPI bus
  mfrc522.PCD_Init();   // Init MFRC522
  delay(4);       // Optional delay. Some board do need more time after init to be ready, see Readme
  mfrc522.PCD_DumpVersionToSerial();  // Show details of PCD - MFRC522 Card Reader details
  Serial.println(F("Scan PICC to see UID, SAK, type, and data blocks..."));

  
}


void checkweight() // function used for checking current weight of load

    {
        
        if (scale.is_ready()) 
        {
          reading = scale.read(); // Output of AD converter HX711
          Serial.print("HX711 reading: ");
          
    } 
      else 
      {
    Serial.println("HX711 not found.");
       }
    }

void motorhandler() // drive the line follower robot
{   
  int m1=digitalRead(A0); // Left Sensor output
  int m2=digitalRead(A1); // Right Sensor output
  
  
  if (m1==0 & m2==0)
     {
      //MOVE FORWARD//
      analogWrite (motorpwm1, 80); 
      analogWrite (motorpwm2, 80);
      digitalWrite ( motoren1, HIGH);// Motor1 Fowrard
      digitalWrite ( motoren2, HIGH);// Motor2 Fowrard
      digitalWrite ( motorev1, LOW);
      digitalWrite ( motorev2, LOW);
      }
  else if (m1==1 & m2==0)
      {//MOVE RIGHT//
        analogWrite (motorpwm1, 70);
      analogWrite (motorpwm2, 120);
      digitalWrite ( motoren1, LOW);
      digitalWrite ( motoren2, HIGH);// Motor2 Fowrard
      digitalWrite ( motorev1, HIGH);// Motor1 reverse
      digitalWrite ( motorev2, LOW);
      }

   else if (m1==0 & m2==1)
      {//MOVE LEFT//
        analogWrite (motorpwm1, 120);
      analogWrite (motorpwm2, 70);
      digitalWrite ( motoren1, HIGH);// Motor1 Fowrard
      digitalWrite ( motoren2, LOW);
      digitalWrite ( motorev1, LOW);
      digitalWrite ( motorev2, HIGH);// Motor1 Reverse
      }   
  else if (m1==1 & m2==1)
      {//STOP//
        analogWrite (motorpwm1, 0); 
      analogWrite (motorpwm2, 0);
      digitalWrite ( motoren1, LOW);
      digitalWrite ( motoren2, LOW);
      digitalWrite ( motorev1, LOW);
      digitalWrite ( motorev2, LOW);
      }   
}   


void RFIDcheck() // to check position of robot
{
  
  mfrc522.PCD_Reset(); // RFID redader reset
  SPI.begin();
   mfrc522.PCD_Init(); // RFID begin
 // Look for new cards
  if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    pos=0;
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) 
  {
    pos=0;
    return;
  }
  //Show UID on serial monitor
  Serial.print("UID tag :");
  String content= "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++) 
  {
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     Serial.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print("Message : ");
  content.toUpperCase();
  if (content.substring(1) == "59 EB A1 59") //change here the UID of the card/cards that you want to give access - Loading point RFID
  {
    Serial.println("Authorized access");
   pos=1;
    delay(500);
   }
 if (content.substring(1) == "77 2B B5 46")//change here the UID of the card/cards that you want to give access - Unoading point RFID
 {
    Serial.println("Authorized access");
    pos=2;
    delay(500); 
  } 
}



void loop()

{ 
          

  RFIDcheck();
  Serial.print("Postion:- ");
  Serial.println(pos); // POS-1 loading, POS-2 Unloading, POS- 0 On the track
  checkweight();
  Serial.println(reading);



if (pos==0) // ON the track
    { motorhandler();
      Servo1.write(0); // Shut unloading Valve/Servo
     
      
    }
if (pos==1) // On loading Station

    {  
     
      while(reading<=85000) // define Max Load of Robot- calibrate as per your load cell
      {
          checkweight();
          Serial.println(reading);
          analogWrite (motorpwm1, 0); // Stop All Motor
          digitalWrite ( motoren1, LOW);
          analogWrite (motorpwm2, 0);
          digitalWrite ( motoren2, LOW);
          delay(500);
          
      }
     
    }


if (pos==2)// On unloading Station

    {     
      while(reading>=80000)// Bare reading of Load Cell-calibrate as per your load cell
      
      {
         checkweight();
         Serial.println(reading);
        analogWrite (motorpwm1, 0);// Stop All Motor
      digitalWrite ( motoren1, LOW);
      analogWrite (motorpwm2, 0);
      digitalWrite ( motoren2, LOW);
      delay(500);
      Servo1.write(180);
      
      }
      
    }
      

}
